src/main/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('notes.urls')),
    path('admin/', admin.site.urls),
]

src/notes/urls.py
from django.urls import path

from . import views

app_name = 'notes'
urlpatterns = [
    path('', views.index, name='index'),
    path('note_new', views.note_new, name='note_new'),
    path('<int:note_id>/edit', views.note_edit, name='note_edit'),
    path('<int:note_id>/save', views.note_save, name='note_save'),
    path('<int:note_id>/delete', views.note_delete, name='note_delete'),
]

src/notes/models.py
from django.db import models


class Note(models.Model):
    note_text = models.CharField(max_length=255)

    def __str__(self):
        return self.note_text

src/notes/forms.py
from django import forms


class NoteForm(forms.Form):
    id = forms.IntegerField()
    note_text = forms.CharField()

src/notes/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse

from .forms import NoteForm
from .models import Note

# Create your views here.
# controller/request handler


def index(request):
    notes = Note.objects.order_by('id')[:10]
    return render(request, 'index.html', {
        'notes': notes
    })


def note_new(request):
    return render(request, 'note_new.html')


def note_edit(request, note_id):
    try:
        note = Note.objects.get(id=note_id)
    except Note.DoesNotExist as ex:
        print(ex)

    return render(request, 'note_edit.html', {
        'note': note
    })


def note_save(request, note_id):
    if request.method == 'POST':
        form = NoteForm(request.POST)
        note_text = form.data['note_text']

        if note_id == 0:
            note = Note.objects.create(note_text=note_text)
            note.save()
        else:
            try:
                note = Note.objects.get(id=note_id)
                note.note_text = note_text
                note.save()
            except Note.DoesNotExist as ex:
                print(ex)

    return HttpResponseRedirect(reverse('notes:index'))


def note_delete(request, note_id):
    try:
        note = Note.objects.get(id=note_id)
        note.delete()
    except Note.DoesNotExist as ex:
        print(ex)

    return HttpResponseRedirect(reverse('notes:index'))

src/templates/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Notes</title>
    <link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet">
</head>
<body>
<div class="container">
    <div class="row">
        <div class="col">
            {% block content %}
            {% endblock %}
        </div>
    </div>
</div>
<script src="{% static 'js/bootstrap.bundle.min.js' %}"></script>
</body>
</html>

src/templates/index.html
{% extends 'base.html' %}
{% block content %}
    <h1>NOTES</h1>

    <div class="container mb-3">
        <div class="row">
            <div class="col">
                <a href="{% url 'notes:note_new' %}" class="btn btn-primary">New</a>
            </div>
        </div>
    </div>

    {% for note in notes %}
    <div class="card mb-3" style="width: 18rem;">
        <div class="card-body">
            <h5 class="card-title">Note #{{ note.id }}</h5>
            <p class="card-text">{{ note.note_text }}</p>
            <a href="{% url 'notes:note_edit' note.id %}" class="btn btn-primary">Edit</a>
            <a href="{% url 'notes:note_delete' note.id %}" class="btn btn-danger">Delete</a>
        </div>
    </div>
    {% endfor %}
{% endblock %}

src/templates/note_edit.html
{% extends 'base.html' %}
{% block content %}
    <div class="container mt-3">
        <div class="row mb-3">
            <div class="col">
                <a href="{% url 'notes:index' %}" class="btn btn-primary">Back</a>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <form action="{% url 'notes:note_save' note.id %}" method="POST">
                    {% csrf_token %}
                    {{ form }}
                    <div class="mb-3">
                        <label for="note_text" class="form-label h2">Note #{{ note.id }}</label>
                        <textarea class="form-control" id="note_text" name="note_text" rows="20" cols="8">{{ note.note_text }}</textarea>
                    </div>
                    <button type="submit" class="btn btn-primary float-end">Save</button>
                </form>
            </div>
        </div>
    </div>
{% endblock %}

src/templates/note_new.html
{% extends 'base.html' %}
{% block content %}
    <div class="container mt-3">
        <div class="row mb-3">
            <div class="col">
                <a href="{% url 'notes:index' %}" class="btn btn-primary">Back</a>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <form action="{% url 'notes:note_save' 0 %}" method="POST">
                    {% csrf_token %}
                    {{ form }}
                    <div class="mb-3">
                        <label for="note_text" class="form-label h2">New Note</label>
                        <textarea class="form-control" id="note_text" name="note_text" rows="20" cols="8"></textarea>
                    </div>
                    <button type="submit" class="btn btn-primary float-end">Save</button>
                </form>
            </div>
        </div>
    </div>
{% endblock %}